import { InjectRedis } from '@liaoliaots/nestjs-redis';
import { Injectable } from '@nestjs/common';
import { Redis } from 'ioredis';
import { IConfigurationRepository } from '../../domain/interfaces/configuration.repository';

@Injectable()
export class RedisConfigurationRepository extends IConfigurationRepository {
  constructor(@InjectRedis() private readonly redis: Redis) {
    super();
  }

  async get(key: string): Promise<string> {
    return await this.redis.get(key);
  }

  async set(key: string, value: string) {
    await this.redis.set(key, value);
  }

  async del(key: string) {
    await this.redis.del(key);
  }
}
