import { CommandHandler } from '@nestjs/cqrs';
import { RedisConfigurationRepository } from '../../adapters/secondaries/redis-configuration.repository';
import { DeleteConfigurationCommand } from '../../commands/delete-configuration.command';

@CommandHandler(DeleteConfigurationCommand)
export class DeleteConfigurationUseCase {
  constructor(private configurationRepository: RedisConfigurationRepository) {}

  execute = async (
    deleteConfigurationCommand: DeleteConfigurationCommand,
  ): Promise<void> => {
    await this.configurationRepository.del(
      deleteConfigurationCommand.deleteConfigurationRequest.domain +
        ':' +
        deleteConfigurationCommand.deleteConfigurationRequest.key,
    );
  };
}
