import { QueryHandler } from '@nestjs/cqrs';
import { RedisConfigurationRepository } from '../../adapters/secondaries/redis-configuration.repository';
import { GetConfigurationQuery } from '../../queries/get-configuration.query';

@QueryHandler(GetConfigurationQuery)
export class GetConfigurationUseCase {
  constructor(private configurationRepository: RedisConfigurationRepository) {}

  execute = async (
    getConfigurationQuery: GetConfigurationQuery,
  ): Promise<string> =>
    this.configurationRepository.get(
      getConfigurationQuery.domain + ':' + getConfigurationQuery.key,
    );
}
