import { QueryHandler } from '@nestjs/cqrs';
import { ICollection } from 'src/modules/database/interfaces/collection.interface';
import { TerritoriesRepository } from '../../adapters/secondaries/territories.repository';
import { FindAllTerritoriesForPointsQuery } from '../../queries/find-all-territories-for-points.query';
import { Territory } from '../entities/territory';

@QueryHandler(FindAllTerritoriesForPointsQuery)
export class FindAllTerritoriesForPointsUseCase {
  constructor(private readonly repository: TerritoriesRepository) {}

  execute = async (
    findAllTerritoriesForPointsQuery: FindAllTerritoriesForPointsQuery,
  ): Promise<ICollection<Territory>> =>
    this.repository.findForPoints(findAllTerritoriesForPointsQuery.points);
}
