import { QueryHandler } from '@nestjs/cqrs';
import { ICollection } from 'src/modules/database/interfaces/collection.interface';
import { TerritoriesRepository } from '../../adapters/secondaries/territories.repository';
import { FindAllTerritoriesQuery } from '../../queries/find-all-territories.query';
import { Territory } from '../entities/territory';

@QueryHandler(FindAllTerritoriesQuery)
export class FindAllTerritoriesUseCase {
  constructor(private readonly repository: TerritoriesRepository) {}

  execute = async (
    findAllTerritoriesQuery: FindAllTerritoriesQuery,
  ): Promise<ICollection<Territory>> =>
    this.repository.findAll(
      findAllTerritoriesQuery.page,
      findAllTerritoriesQuery.perPage,
    );
}
